"use strict";

import * as GeneralController from "../../Global/GeneralController.js";
import * as HelpScreen        from "../HelpScreen/HelpScreen.js";
import * as GlobalData        from "../../Global/GlobalData.js";

import { class_RepetitionChecker } from "../../Util/Class_RepetitionChecker.js";

const repetitionChecker = new class_RepetitionChecker();

export function handleGameTick()
{
	handleInput();
	HelpScreen.handleGameTick();
}

function handleInput()
{
	if (!repetitionChecker.isRepeating(GeneralController.userInput))
	{
		switch (GeneralController.userInput)
		{
			case GlobalData.enumUserInput.TITLE_SCREEN : GeneralController.switchToTitleScreen() ; break;
			case GlobalData.enumUserInput.HELP_SCREEN  : GeneralController.switchToHelpScreen()  ; break;
			case GlobalData.enumUserInput.PLAY_SCREEN  : GeneralController.switchToPlayScreen()  ; break;
		}
	}
}
