"use strict";

import * as TileBorderManager from "../../Util/TileBorderManager.js";
import * as GameField  from "../../Global/GameField.js";
import { class_Delay } from "../../Util/Class_Delay.js";
import * as Tools      from "../../Util/Tools.js";
import * as View              from "../../Util/View.js";

import { class_BlinkingText } from "../../Util/Class_BlinkingText.js";

const textBlinking_01 = new class_BlinkingText("Press 'F3' to play", "20px Verdana", 35, 160);

const delay = new class_Delay(500);
let toggleAnimation = true;

export function init()
{
}

export function handleGameTick()
{
	if (delay.hasExpired())
	{
		toggleAnimation = !toggleAnimation;
	}

	drawContent();
}

function drawContent()
{
	View.context.globalAlpha = 0.25
	GameField.render();
	TileBorderManager.render();
	View.context.globalAlpha = 1.0

	let X;
	let Y = 150;

	let text = "ClickMania";
	View.context.font = "bold 60px Verdana";
	X = Tools.calculateTextXcoordinate(text);
	View.context.fillStyle = "red";
	View.context.fillText(text, X, Y);
	View.context.strokeStyle = "black";
	View.context.strokeText(text, X, Y);

	View.context.shadowColor = "grey";
	View.context.shadowOffsetX = 1;
	View.context.shadowOffsetY = 1;
	View.context.shadowBlur = 1;

	Y = 240;
	text = "select the map you want to play :";
	View.context.font = "20px Verdana";
	X = Tools.calculateTextXcoordinate(text);
	View.context.fillStyle = "black";
	View.context.fillText(text, X, Y);

	//---

	Y += 65;
	X = 282;
	text = "score :";
	View.context.font = "20px Verdana";
	View.context.fillStyle = "black";
	View.context.fillText(text, X, Y);

	X += 110;
	text = "hi-score :";
	View.context.font = "20px Verdana";
	View.context.fillStyle = "black";
	View.context.fillText(text, X, Y);

	//---

	Y = 350;
	createLine(Y, "Map 01", "00010", "00020");
	createLine(Y += 50, "Map 02", "00030", "00040");
	createLine(Y += 50, "Map 03", "00050", "00060");
	createLine(Y += 50, "Map 04", "00070", "00080");
	createLine(Y += 50, "Map 05", "00050", "00060");
	createLine(Y += 50, "Map 06", "00050", "00060");
	createLine(Y += 50, "Map 07", "00050", "00060");

	//---

	X = 250;
	Y += 50;

	createButton(X, Y);

	drawSelectionBar();
	View.context.shadowColor = "rgba(0,0,0,0)"; // Restore default-value / turn-off shadowing.
}

function createLine(Y, mapName, score, hiScore)
{
	let X = 130;

	View.context.font = "bold 25px Verdana";
	View.context.fillStyle = "red";
	View.context.fillText(mapName, X, Y);

	X += 150;
	View.context.font = "bold 20px Verdana";
	View.context.fillStyle = "teal";
	View.context.fillText(score, X, Y);

	X += 120;
	View.context.fillText(hiScore, X, Y);
}

function createButton(X, Y)
{
	View.context.lineWidth = 2.0;
	View.context.strokeStyle = "black";
	View.context.strokeRect(X,Y,125,45);

	View.context.font = "bold 20px Verdana";
	View.context.fillStyle = "black";
	View.context.fillText("play", X += 38, Y += 28);
}

function drawSelectionBar()
{
	if (toggleAnimation)
	{
		View.context.setLineDash([15, 5]);
	}
	else
	{
		View.context.setLineDash([10, 5]);
	}

	Tools.drawOvalStroked(130, 390,340, 24);
	View.context.setLineDash([0]); // Restore default-value.
}
