"use strict";

import { class_Delay } from "../Class_Delay.js";
import * as View       from "../View.js";

export class class_TextPopup
{
	#delayDuration = new class_Delay(500);

	#text
	#X
	#Y

	constructor(key, text, X, Y)
	{
		this.#text = text;
		this.#X = X;
		this.#Y = Y;

		this.isFinished  = false;
		this.#delayDuration.reset();
	}

	handleGameTick()
	{
		if (this.#delayDuration.hasNotExpired())
		{
			this.#render();
		}
		else
		{
			this.isFinished = true;
		}
	}

	#render()
	{
		const width = View.context.measureText(this.#text).width + 65;

		View.context.lineWidth = 3.0;
		View.context.strokeStyle = "white";

		View.context.beginPath();
		View.context.rect (this.#X - 20, this.#Y - 35, width,50);

		View.context.fillStyle = "black";
		View.context.stroke();
		View.context.fill();

		View.context.font = "bold 30px Verdana";
		View.context.fillStyle = "red";
		View.context.fillText(this.#text, this.#X, this.#Y);
	}

}
